precision mediump float;
uniform vec3 uLightDir;
uniform float uDirIntensity;
varying vec4 vColor;
varying vec3 vNormal;

void main() {
    if (vColor.a == 1.0) {
        gl_FragColor = vec4(vColor.rgb, 1.0);
        return;
    }
    float lambert_factor = max(dot(normalize(vNormal), uLightDir), 0.0);
    gl_FragColor = vec4(vColor.rgb * min(vColor.a + uDirIntensity * lambert_factor, 1.0), 1.0);
}