uniform mat4 uMatrix;
uniform mat4 uMatrixMV;
uniform vec3 uColor;
uniform float uAmbIntensity;
attribute vec4 aPosition;
attribute vec3 aNormal;
attribute vec4 aColorData;
varying vec4 vColor;
varying vec3 vNormal;

const float COLOR_UNIT = 1.0 / 255.0;
void main() {
    gl_Position = uMatrix * aPosition;
    vNormal = mat3(uMatrixMV) * aNormal;
    if (uColor.r < 0.0) {
        vColor = vec4(aColorData.rgb * COLOR_UNIT, bool(aColorData.a) ? uAmbIntensity : 1.0);
    } else {
        vColor = vec4(uColor, uAmbIntensity);
    }
}