precision mediump float;
uniform sampler2D uTexUnit;
uniform bool uIsTransparency;
varying vec4 vTexture;
varying vec4 vSpriteBounds;

void main() {
    if (any(lessThan(gl_PointCoord, vSpriteBounds.st)))
        discard;
    vec2 spCoord = gl_PointCoord - vSpriteBounds.st;
    if (any(greaterThan(spCoord, vSpriteBounds.pq)))
        discard;
    vec4 color = texture2D(uTexUnit, spCoord / vSpriteBounds.pq * vTexture.pq + vTexture.st);
    if (uIsTransparency && color.a < 1.0)
            discard;
    gl_FragColor = vec4(color.rgb, 1.0);
}