uniform mat4 uMatrix;
uniform mat4 uMatrixMV;
uniform vec4 uTexCoord;
uniform vec2 uTexSize;
uniform vec3 uSize;
uniform vec2 uScreenSize;
attribute vec4 aPosition;
attribute vec4 aColorData;
attribute vec3 aSize;
varying vec4 vTexture;
varying vec4 vSpriteBounds;

void main() {
    vec4 eye = uMatrixMV * aPosition;
    gl_Position = uMatrix * eye;
    vec4 texSize = vec4(uTexSize.x, uTexSize.y + 1.5, uTexSize);
    vec4 texCoord = (uTexCoord.s < 0.0 ? aColorData : uTexCoord) / texSize;
    vec2 texFragSize = (texCoord.pq - texCoord.st);
    vTexture = vec4(texCoord.st, texFragSize);
    vec3 spriteSize = uSize.x > 0.0 ? uSize : aSize;
    vec2 ss = vec2(spriteSize.xy);
    if (spriteSize.z < 0.5) {
        vec2 projCorner = vec2(uMatrix[0][0] * ss.x * 0.5, uMatrix[1][1] * ss.y * 0.5);
        ss = abs(vec2(uScreenSize.xy * projCorner.xy / eye.z));
    }
    float max = max(ss.x, ss.y);
    gl_PointSize = max;
    vec2 padding = (max - ss) / 2.0;
    vSpriteBounds = vec4(padding / max, ss / max);
}