precision mediump float;
uniform sampler2D uTextureUnit;
uniform vec3 uLightDir;
uniform float uDirIntensity;
varying vec4 vTexture;
varying vec3 vNormal;

void main() {
    vec4 color = texture2D(uTextureUnit, vTexture.st);
    if (bool(vTexture.p) && color.a < 1.0)
            discard;
    if (vTexture.a == 1.0) {
        gl_FragColor = vec4(color.rgb, 1.0);
        return;
    }
    float lambert_factor = max(dot(normalize(vNormal), uLightDir), 0.0);
    gl_FragColor = vec4(color.rgb * min(vTexture.a + uDirIntensity * lambert_factor, 1.0), 1.0);
}