uniform mat4 uMatrix;
uniform mat4 uMatrixMV;
uniform vec2 uTexSize;
uniform bool uIsTransparency;
uniform float uAmbIntensity;
attribute vec4 aPosition;
attribute vec3 aNormal;
attribute vec4 aColorData;
varying vec4 vTexture;
varying vec3 vNormal;
void main() {
    gl_Position = uMatrix * aPosition;
    vNormal = mat3(uMatrixMV) * aNormal;
    float amb = bool(aColorData.a) ? uAmbIntensity : 1.0;
    float colorKey = uIsTransparency ? 1.0 : aColorData.p;
    vTexture = vec4((aColorData.st + 0.5) / uTexSize, colorKey, amb);
}